import { debounce, isNil } from 'lodash';
import { FC, ReactNode } from 'react';

import { useLifecycles } from 'react-use';

import { useThemeStore } from './store';

const Theme: FC<{ children?: ReactNode }> = ({ children }) => {
    let unSub: () => void;

    useLifecycles(
        () => {
            useThemeStore.subscribe(
                (state) => state.mode,
                (mode) => {
                    debounce(() => {
                        console.log(mode);
                    });
                    const body = document.getElementsByTagName('body');
                    if (body.length) {
                        body[0].classList.remove('light');
                        body[0].classList.remove('dark');
                        body[0].classList.add(mode === 'dark' ? 'dark' : 'light');
                    }
                },
                // debounce(
                //     () => {
                //         const body = document.getElementsByTagName('body');
                //         if (body.length) {
                //             body[0].classList.remove('light');
                //             body[0].classList.remove('dark');
                //             body[0].classList.add(mode === 'dark' ? 'dark' : 'light');
                //         }
                //     },
                //     10,
                //     {},
                // ),
                {
                    fireImmediately: true,
                },
            );
        },
        () => {
            if (!isNil(unSub)) unSub();
        },
    );

    return <>{children}</>;
};
export default Theme;
